// MicrosoftWordpad script version 1.0

using LoginPI.Engine.ScriptBase;

public class MicrosoftWordpad : ScriptBase
{
    private void Execute()
    {      
        
        // Define environementvariables to use with Workload
        var temp = GetEnvironmentVariable("TEMP");

        // Download file from appliance, if it already exists skip the download.
        if(!(FileExists($"{temp}\\LoginPI\\loginvsi.rtf")))
        {
            Log("Downloading File");
            CopyFile(KnownFiles.RichTextFile, $"{temp}\\LoginPI\\loginvsi.rtf");
        }
        else
        {
            Log("File already exists");
        }

        // Start Application
        START();
        MainWindow.Maximize();
        Wait(2);

        // Open "Open File" window and start measurement.
        MainWindow.Type("{CTRL+O}");
        StartTimer("Open_Window");
        var OpenWindow = FindWindow(title : "Open");
        OpenWindow.FindControl(className : "Button:Button", title : "&Open").Click();
        StopTimer("Open_Window");

        // Navigate to copied RTF file and press Open, measure time to open the file.
        OpenWindow.FindControl(className : "Edit:Edit", title : "File name:").Click();
        Wait(1);
        OpenWindow.Type($"{temp}\\LoginPI\\loginvsi.rtf",cpm:300);
        Wait(1);
        OpenWindow.FindControl(className : "Button:Button", title : "&Open").Click();
        StartTimer("Open_WordPad_Document");
        MainWindow.FindControl(className : "Button", title : "File tab");
        StopTimer("Open_WordPad_Document");

        // Scroll through RTF Document
        MainWindow.MoveMouseToCenter();
        MouseDown();
        Wait(1);
        MouseUp();
        MainWindow.Type("{PAGEDOWN}".Repeat(20));
        Wait(1);
        MainWindow.Type("{PAGEUP}".Repeat(20));

        // Type in the document
        MainWindow.MoveMouseToCenter();
        MouseDown();
        Wait(1);
        MouseUp();
        MainWindow.Type("Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.",cpm : 300);
        Wait(1);

        MainWindow.Type("{PAGEDOWN}");
        MainWindow.MoveMouseToCenter();
        MouseDown();
        Wait(1);
        MouseUp();
        MainWindow.Type("Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.",cpm : 300);

        Wait(2);

        // Remove file if it already exists
        if(FileExists($"{temp}\\LoginPI\\loginvsi_edited.rtf"))
        {
            Log("Removing file");
            RemoveFile(path:$"{temp}\\LoginPI\\loginvsi_edited.rtf");
        }
        else
        {
            Log("File already removed");
        }       

        // Saving the file in temp 
        MainWindow.Type("{ALT+F+A}");
        var SaveAs = FindWindow(title:"Save As");
        SaveAs.Type($"%temp%\\LoginPI\\loginvsi_edited.rtf",cpm:300);
        StartTimer("Saving_file");
        SaveAs.Type("{ENTER}");
        FindWindow(title: "loginvsi_edited*");
        StopTimer("Saving_file");
        Wait(2);

        STOP();
    }
}